<?php

namespace EventPortal\Seeds;

use EventPortal\Domain\Permission\Models\Group;
use EventPortal\Domain\Permission\Models\Permission;
use Illuminate\Database\Seeder;
use Illuminate\Support\Str;

class PermissionSeeder extends Seeder
{
    public function run(): void
    {
        collect(config('permissions'))
            ->each(static function (array $permission, string $group): void {
                $group = Group::firstOrCreate([
                    'name' => Str::slug($group),
                    'label' => Str::ucfirst($group),
                ]);

                collect($permission)->each(static function (array $permission) use ($group): void {
                    Permission::updateOrCreate([
                        'name' => $permission['name'],
                        'label' => $permission['label'],
                        'guard_name' => 'web',
                        'group_id' => $group->id,
                    ]);
                });
            });
    }
}
